
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;
import java.awt.GraphicsConfiguration;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.behaviors.keyboard.*;
import com.sun.j3d.utils.picking.PickTool;
import vrml.*;
import com.sun.j3d.loaders.vrml97.*;
import java.io.FileNotFoundException;
import java.util.Enumeration;

public class CS488Test extends Applet {

  BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);

  public BranchGroup createSceneGraph () {

    // Create the root of the branch graph
    BranchGroup objRoot = new BranchGroup();

    // Set up the ambient light
    Color3f ambientColor = new Color3f(0.1f, 0.1f, 0.1f);
    AmbientLight ambientLightNode = new AmbientLight(ambientColor);
    ambientLightNode.setInfluencingBounds(bounds);
    objRoot.addChild(ambientLightNode);

    // Set up the directional lights
    Color3f light1Color = new Color3f(1.0f, 1.0f, 0.9f);
    Vector3f light1Direction  = new Vector3f(4.0f, -7.0f, -12.0f);
    Color3f light2Color = new Color3f(0.3f, 0.3f, 0.4f);
    Vector3f light2Direction  = new Vector3f(-6.0f, -2.0f, -1.0f);

    DirectionalLight light1
      = new DirectionalLight(light1Color, light1Direction);
    light1.setInfluencingBounds(bounds);
    objRoot.addChild(light1);

    DirectionalLight light2
      = new DirectionalLight(light2Color, light2Direction);
    light2.setInfluencingBounds(bounds);
    objRoot.addChild(light2);

    VrmlLoader loader = new VrmlLoader();
    MyObject vrml = new MyObject();
    try {
      // change this file to your file and objectname.
      vrml.addChild(loader.load("turtle.wrl").getSceneGroup());
    }
    catch (FileNotFoundException fnfe) {}

    Object childobject=vrml.getChild(0);
    Object childobject2 = ((BranchGroup)childobject).getChild(0);
    TransformGroup tgroot=(TransformGroup)childobject2;
    //Object shapeobject =tgroot.getChild(0);
    //tgroot.getA
    Enumeration en = tgroot.getAllChildren();
    while(en.hasMoreElements()) {
      Object o = en.nextElement();
      System.out.println(o.getClass().getName());
      if(o instanceof Shape3D) {
        ((Shape3D)o).setPickable(true);
        ((Shape3D)o).setCapability(Shape3D.ALLOW_GEOMETRY_READ);
        ((Shape3D)o).setCapability(Shape3D.ALLOW_PICKABLE_READ);
        PickTool.setCapabilities(((Shape3D)o), PickTool.INTERSECT_FULL);
        //System.out.println("num Geometries: " + ((Shape3D)o).numGeometries());
      }
      else if(o instanceof Link) {
        ((Link)o).setCapability(Link.ALLOW_PICKABLE_READ);
      }
      else if(o instanceof TransformGroup) {
        ((TransformGroup)o).setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
      }
   }
    Transform3D t3 = new Transform3D ();
    t3.setTranslation(new Vector3d(0.0, 0.0, -2.0));
    TransformGroup objTrans = new TransformGroup(t3);
    objTrans.addChild(vrml);
    objRoot.addChild(objTrans);
    return objRoot;
  }

  public CS488Test () {
    setLayout(new BorderLayout());

    GraphicsConfiguration config =
      SimpleUniverse.getPreferredConfiguration();

    Canvas3D c = new Canvas3D(config);
    add("Center", c);

    // Create a simple scene and attach it to the virtual universe
    BranchGroup scene = createSceneGraph();
    SimpleUniverse u = new SimpleUniverse(c);

    // Add picking behavior
    CS488Behavior behavior = new CS488Behavior ();
    behavior.setSchedulingBounds (bounds);
    scene.addChild (behavior);

    TransformGroup vpTrans =
      u.getViewingPlatform().getViewPlatformTransform();

    KeyNavigatorBehavior keybehavior = new KeyNavigatorBehavior (vpTrans);
    keybehavior.setSchedulingBounds (bounds);
    scene.addChild (keybehavior);
    scene.setCapability (Group.ALLOW_CHILDREN_EXTEND);
    scene.compile();
    u.addBranchGraph(scene);

    View view = u.getViewer().getView();
    //view.set
    view.setBackClipDistance (1000);

  }

  //
  // The following allows IntersectTest to be run as an application
  // as well as an applet
  //
  public static void main(String[] args) {
    String s = "\n\nIntersectTest:\n-----------\n";
    s += "Pick with the mouse over the primitives\n";
    s += "- A sphere will be placed to indicate the picked point.\n";
    s += "If color information is available, the sphere will change color to reflect\n";
    s += "the interpolated color.\n";
    s += "- Other spheres will be placed to show the vertices of the selected polygon\n";
    s += "- Information will be displayed about the picking operation\n\n\n";

    System.out.println (s);

    new MainFrame(new CS488Test(), 640, 640);
  }
}
